 mongoose = require('mongoose').set('debug', false)
const Schema = mongoose.Schema;

const tools = require('../tools/general');

mongoose.Promise = global.Promise;
mongoose.level = "F";


// Resolving error Unknown modifier: $pushAll
mongoose.plugin(schema => {
  schema.options.usePushEach = true
});

const gasordineSchema = new Schema({
  active: {
    type: Boolean,
  },
  idapp: {
    type: String,
  },
  name: {
    type: String,
  },
  description: {
    type: String,
  },
  referente: {
    type: String,
  },
  city: {
    type: String,
  },
  img: {
    type: String,
  },
  note_ordine_gas: {
    type: String,
  },

  dataora_chiusura_ordini: {
    type: Date,
  },
  data_arrivo_merce: {
    type: Date,
  },
  dataora_ritiro: {
    type: Date,
  },
  dataora_termine_pagamento: {
    type: Date,
  },

});

var Gasordine = module.exports = mongoose.model('Gasordine', gasordineSchema);

module.exports.getFieldsForSearch = function () {
  return [
    {field: 'name', type: tools.FieldType.string},
    {field: 'description', type: tools.FieldType.string},
  ]
};

module.exports.executeQueryTable = function (idapp, params) {
  params.fieldsearch = this.getFieldsForSearch();
  return tools.executeQueryTable(this, idapp, params);
};

module.exports.findAllIdApp = async function (idapp) {
  const myfind = { idapp };

  return await Gasordine.find(myfind).sort({dataora_chiusura_ordini: -1}).lean();
};


module.exports.getGasordineByID = function (id, callback) {
  Gasordine.findById(id, callback);
}

module.exports.createIndexes()
  .then(() => { })
  .catch((err) => { throw err; });

